'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Flash = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Flash_actions = require('./Flash_actions');

var _reactRedux = require('react-redux');

var _redux = require('redux');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Flash = exports.Flash = function (_Component) {
  _inherits(Flash, _Component);

  function Flash() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Flash);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Flash.__proto__ || Object.getPrototypeOf(Flash)).call.apply(_ref, [this].concat(args))), _this), _this.componentDidMount = function () {
      //provides event listener for outside component click
      document.addEventListener('click', _this.handleOutsideClick, false);
    }, _this.componentWillUnmount = function () {
      //removes the event listener on unmount
      document.removeEventListener('click', _this.handleOutsideClick, false);
    }, _this.handleOutsideClick = function (e) {
      if (!_reactDom2.default.findDOMNode(_this).contains(e.target)) {
        _this.props.hideFlash();
      }
    }, _this.renderFlash = function () {
      if (_this.props.flashState.show) return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(
          'div',
          { className: _this.props.flashState.status ? 'panel panel-' + _this.props.flashState.status.toLowerCase() : 'panel panel-danger' },
          _react2.default.createElement(
            'div',
            { className: 'panel-heading' },
            _react2.default.createElement(
              'h3',
              { className: 'panel-title' },
              _this.props.flashState.status ? _this.props.flashState.status.toUpperCase() : 'DANGER'
            )
          ),
          _react2.default.createElement(
            'div',
            { className: 'panel-body' },
            _this.props.flashState.message
          )
        )
      );
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Flash, [{
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        'div',
        null,
        this.renderFlash()
      );
    }
  }]);

  return Flash;
}(_react.Component);

// these props are all provided through the actions


Flash.propTypes = {
  hideFlash: _propTypes2.default.func,
  show: _propTypes2.default.bool,
  message: _propTypes2.default.string,
  status: _propTypes2.default.string
};

function mapStateToProps(state) {
  return Object.assign({}, state);
}

function mapDispatchToProps(dispatch) {
  return (0, _redux.bindActionCreators)({ showFlash: _Flash_actions.showFlash, hideFlash: _Flash_actions.hideFlash }, dispatch);
}

exports.default = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps)(Flash);